// 10 Mar 2007
// Copyright (c) 2007, Miguel Novas
// Released under the GPL license
// http://www.gnu.org/copyleft/gpl.html
// Panel configuracion para el Script de compactacion automatica de batallas de ogame

const defaultImagesLabels= 'Eyes;Sun;Trees';
const defaultImages      = imageDefault + ';http://www.science.siu.edu/images/line-hr-sun.gif;http://www.science.siu.edu/images/line-hr-trees.gif';

function create_config()
{
  TimerTrans= null;
  // Stylesheet
  var sheet= document.styleSheets[0];
  sheet.insertRule("#compactador-config { -moz-border-radius: 7px; -moz-opacity:0.4; position:fixed; top:8px; right:8px; width:118px; background-color:#F0F0E3; color:black; padding:0px; }", 0);
  sheet.insertRule("#compactador-config, #compactador-config input, #compactador-config select { font-family: Tahoma,sans-serif;  font-size: 11px; }", 0);
  sheet.insertRule("#compactador-config fieldset { -moz-border-radius: 3px; border: 1px solid gray; margin: 2px 4px 2px 5px; padding: 2px 2px 5px 3px; }", 0);
  sheet.insertRule("#compactador-config legend  { margin-left:2px; }", 0);
  sheet.insertRule("#compactador-config input  { display:inline; margin: 0px 4px 0px 2px; background-color:white; color:black; cursor:pointer; }", 0);
  sheet.insertRule("#compactador-config label  { display:block; cursor:pointer; margin: 3px auto;}", 0);
  sheet.insertRule("#compactador-config select {  border: 1px #415680 solid; padding:0px; margin: 1px 2px 0px 2px; background-color:white; color:black; cursor:pointer; }", 0);
  sheet.insertRule("#compactador-config #hr_image_index { width:76px; }", 0);
  sheet.insertRule("#compactador-config #button-image-change { display:block; float:right; cursor:pointer; width:16px; height:15px; margin-top:1px; margin-right:3px; background: url(chrome://ogamecompactor/content/images/tools.png) no-repeat center center; border:1px solid gray; border-top: 1px solid white; border-left: 1px solid white; }", 0);
  sheet.insertRule("#compactador-config #button-image-change:hover { background-color:#DADADA; }", 0);
  sheet.insertRule("#compactador-config #forum_type { width:72px; }", 0);
  sheet.insertRule("#compactador-config #language { width:96px; }", 0);
  sheet.insertRule("#compactador-config #button-copy:hover { background-color:#DADADA; }", 0);
  sheet.insertRule("#compactador-config #button-copy { cursor:pointer; margin-top: -1px; margin-right:3px; float:right; width:19px; height:18px; background: url(chrome://ogamecompactor/content/images/copy.png) no-repeat center center; border:1px solid gray; border-top: 1px solid white; border-left: 1px solid white; }", 0);
  sheet.insertRule("#compactador-config #splitter          { overflow:hidden; cursor:pointer; height:7px; margin:0px 3px; border-bottom: 1px solid #BBBBBB; }", 0);
  sheet.insertRule("#compactador-config #splitter:hover    { background-color:#DADADA; }", 0);
  sheet.insertRule("#compactador-config #splitter.expand   { background: url(chrome://ogamecompactor/content/images/expand.png) no-repeat bottom center; }", 0);
  sheet.insertRule("#compactador-config #splitter.collapse { background: url(chrome://ogamecompactor/content/images/collapse.png) no-repeat bottom center; }", 0);
  sheet.insertRule("#compactador-config #shareout_flote { width:76px; margin-left:4px; }", 0);

  var config_div= document.createElement("div");
  config_div.id = "compactador-config";

  if(GM_getValue('config_opaque',false)) {
     GM_setValue('config_opaque',false);
     config_make_opaque(config_div, true);
  } else {
     config_div.style.MozOpacity= GM_getValue('hide_config', false) ? 0 : 0.4;
  }
  config_div.addEventListener( 'mouseout' , function(ev) { config_enable_transparency_timer(this); }, true);
  config_div.addEventListener( 'mouseover', function(ev) { config_enable_opaque_timer(this);       }, true);

  // Config panel header
  var fieldset= DomCreateFieldset( t('ZipFor'), config_div );
  DomCreateElement( 'div', { id   :'button-copy',
                             click: function(ev) {
                                       GM_copyToClipboard(document.getElementById("forum_compactation").value);
                                       alert(t('BattleCopiedToClipboard'));
                                    }
                            }, fieldset);

  DomCreateConfigSelect( 'forum_type', null, t('$forums'), 1, fieldset );

  // Config panel body
  var body_div= document.createElement("div");
  body_div.id= 'config_body';
  body_div.style.display= GM_getValue('config_expanded', false) ? 'block' : 'none';
  create_panel_body(body_div);
  config_div.appendChild(body_div);

  // Splitter
  var splitter_div= document.createElement("div");
  splitter_div.id= 'splitter';
  splitter_div.className= 'collapse';
  splitter_div.addEventListener( 'click',
                                 function(ev) {
                                     GM_setValue('config_expanded', !GM_getValue('config_expanded', false));
                                     config_expand_collapse(); },
                                 true);
  config_div.appendChild(splitter_div);
  //
  document.body.appendChild(config_div);
  //
  config_expand_collapse();
}

function create_panel_body(config_div)
{
  var fieldset= DomCreateFieldset( t('Show'), config_div );
  DomCreateConfigInput( 'checkbox', 'old_favour', t('ClassicReport'), false, fieldset);
  DomCreateConfigInput( 'checkbox', 'partials'  , t('Parts')        , false, fieldset);
  DomCreateConfigInput( 'checkbox', 'deuterium' , t('Deuterium')    , false, fieldset);
  DomCreateConfigInput( 'checkbox', 'tecnology' , t('Techs')        , false, fieldset);
  DomCreateConfigInput( 'checkbox', 'coords'    , t('Coordinates')  , false, fieldset);
  DomCreateConfigInput( 'checkbox', 'date_time'    , t('date_time')  , true, fieldset);

  var fieldset= DomCreateFieldset( t('Background'), config_div );
  DomCreateConfigInput( 'checkbox', 'light_forum', t('LightForum'),  true,  fieldset);
  DomCreateConfigInput( 'checkbox', 'light_skin' , t('LightSkin') ,  false, fieldset);

  var fieldset= DomCreateFieldset( t('Image'), config_div );
  DomCreateElement( 'div', { id   :'button-image-change', click: function(ev) { config_action_image_dialog(); } }, fieldset);
  DomCreateConfigSelect( 'hr_image_index', null, GM_getValue('hr_images_labels',defaultImagesLabels).split(';'), 0, fieldset, config_action_change_image );

  var fieldset= DomCreateFieldset( t('Misc'), config_div );
  DomCreateConfigInput( 'checkbox', 'hide_report', t('ShowReport'), false, fieldset);
  DomCreateConfigInput( 'checkbox', 'hide_config', t('HidePanel') , false, fieldset);

  if(shareOutAllowed) {
    var fieldset= DomCreateFieldset( t('ShareOut'), config_div );
    DomCreateConfigInput( 'checkbox', 'shareout_show', t('Show'), false, fieldset);
    if(shareOutDefendersCount>1 && shareOutAttackersCount>1) DomCreateConfigInput( 'checkbox', 'shareout_defenders', t('Defenders'), false, fieldset);

    var fieldset= DomCreateFieldset( t('ShareFloteWeight'), fieldset );
    DomCreateConfigSelect( 'shareout_flote', null, [ ' 0%', '10%','20%','30%','40%','50%','60%','70%','80%' , '90%' , '100%'] , 0, fieldset );
  }

  var fieldset= DomCreateFieldset( t('Language'), config_div );
  DomCreateConfigSelect( 'language', null,  langsNames, 0, fieldset, config_action_refresh );
}

function config_expand_collapse()
{
 var body_div= document.getElementById("config_body");
 var value= GM_getValue('config_expanded', false);
 body_div.style.display= value ? 'block' : 'none';
 var splitter_div= document.getElementById("splitter");
 splitter_div.className=  value ? 'collapse' : 'expand';
}

function config_enable_transparency_timer(element)
{
  config_timer_clear();
  if(parseFloat(element.style.MozOpacity)>=1) {
    TimerTrans= setTimeout( function() { config_make_transparent_event(); }, 2500);
  }
}

function config_enable_opaque_timer(element)
{
  config_timer_clear();
  if(parseFloat(element.style.MozOpacity)<1) {
     TimerTrans= setTimeout( function() { config_make_opaque_event(); }, 250);
  }
}

function config_timer_clear()
{
 if(TimerTrans) {
   clearTimeout(TimerTrans);
   TimerTrans= null;
 }
}

function config_make_opaque(element, enable_timer)
{
 config_timer_clear();
 element.style.MozOpacity= '1';
 if(enable_timer) config_enable_transparency_timer(element);
}

function config_make_transparent_event()
{
 var min  = GM_getValue('hide_config', false) ? 0 : 0.4;
 var item = document.getElementById('compactador-config');
 var opacity= parseFloat(item.style.MozOpacity)-0.025;
 item.style.MozOpacity= opacity;
 if(opacity>min) TimerTrans= setTimeout( function() { config_make_transparent_event(); }, 30);
}

function config_make_opaque_event()
{
 var item= document.getElementById('compactador-config');
 config_make_opaque(item, false);
}

function config_action_default()
{
  config_timer_clear();
  create_report();
}

function config_action_refresh()
{
  GM_setValue('config_opaque',true);
  location.href=document.location;
}

function config_action_change_image(select)
{
  var image= GM_getValue('hr_images',defaultImages).split(';')[select.selectedIndex];
  if(image) {
    GM_setValue('hr_image',image);
    config_action_default();
 }
}

function config_action_image_dialog()
{
  var new_image= false;
  var select= document.getElementById('hr_image_index');
  var index = select.selectedIndex;
  var images= GM_getValue('hr_images'  ,defaultImages).split(';');
  var labels= GM_getValue('hr_images_labels',defaultImagesLabels).split(';'); ;

  if(typeof(ImageDialogSheetInitialized)=='undefined') {
    var sheet= document.styleSheets[0];
    sheet.insertRule("#dialog-background { z-index:10; position: fixed; top:0; left:0; right:0; bottom:0; }", 0);
    sheet.insertRule("#dialog-image { -moz-border-radius:5px; border: 1px solid #C4C4C4; padding: 8px; width:338px; height: 144px; position:absolute; top:0; bottom:0; left:0; right:0; color:black; margin: auto auto; background-color:#ECE9D8; -moz-opacity:1;}", 0);
    sheet.insertRule("#dialog-image, #dialog-image input { font-family: Tahoma,sans-serif;  font-size: 11px; }", 0);
    sheet.insertRule("#dialog-image label { display:block; margin:0;  }", 0);
    sheet.insertRule("#dialog-image legend { font-weight:bolder; margin:0; }", 0);
    sheet.insertRule("#dialog-image fieldset { -moz-border-radius: 0px;  padding: 8px 14px 8px 14px; }", 0);
    sheet.insertRule("#dialog-image input[type=\"text\"] { margin-bottom: 8px; padding:2px; width:100%; background-color: white; color:black; display:block;}", 0);
    sheet.insertRule("#dialog-image input[type=\"button\"]:hover { background-color:#DADADA; }", 0);
    sheet.insertRule("#dialog-image input[type=\"button\"] { display:block; color:black; margin:2px; padding:2px; cursor:pointer; background-color:#F0F0E3;  border:1px solid gray; border-top: 1px solid white; border-left: 1px solid white; margin-top:8px; display:block; float:left; width:80px; }", 0);
    ImageDialogSheetInitialized= true;
  }

  var background= document.createElement('div');
  background.id='dialog-background';

  var dialog= document.createElement('div');
  dialog.id='dialog-image';
  background.appendChild(dialog);

  var fieldset= DomCreateFieldset( t('ChangeImage'), dialog );
  DomCreateLabel( t('Description'), {}, fieldset );
  var image_label= DomCreateInputElement( { type:'text', name:'image-label', value: labels[index] }, fieldset );
  DomCreateLabel( 'URL', {}, fieldset );
  var image_url= DomCreateInputElement( { type:'text'  , name:'image-url', value: images[index] }, fieldset );
  //
  DomCreateInputElement( { type:'button', name:'button-delete', value: t('Delete'),
                           click: function(ev) {
                                    if(!new_image && index>0) {
                                      labels.splice(index,1);
                                      images.splice(index,1);
                                      GM_setValue('hr_images_labels',labels.join(';'));
                                      GM_setValue('hr_images'       ,images.join(';'));
                                      if(index>=images.length) GM_setValue('hr_image_index',images.length-1);
                                      select.remove(index);
                                      document.body.removeChild(background);
                                    }
                                  }
                         }, dialog );
  DomCreateInputElement( { type:'button', name:'button-new', value: t('New'),
                           click: function(ev) {
                                     if(!new_image) {
                                       new_image= true;
                                       index= images.length;
                                       labels[index]= '';
                                       images[index]= '';
                                     }
                                     image_label.value= '';
                                     image_url.value= '';
                                     fieldset.firstChild.innerHTML= t('NewImage');
                                     image_label.focus();
                                  }
                         }, dialog );
  DomCreateInputElement( { type:'button', name:'button-accept', value: t('Accept'),
                           click: function(ev) {
                                    labels[index]= image_label.value;
                                    images[index]= image_url.value;
                                    GM_setValue('hr_images_labels',labels.join(';'));
                                    GM_setValue('hr_images'       ,images.join(';'));
                                    GM_setValue('hr_image_index',index);
                                    GM_setValue('hr_image',image_url.value);
                                    if(new_image) select.add(document.createElement('option'),null);
                                    select.options[index].text= image_label.value;
                                    select.selectedIndex= index;
                                    document.body.removeChild(background);
                                    create_report();
                                  }
                         }, dialog );
  DomCreateInputElement( { type:'button', name:'button-cancel', value: t('Cancel'),
                           click: function(ev) {
                                    document.body.removeChild(background);
                                  }
                          }, dialog );

  document.body.appendChild(background);
}

//////////////////////////////////////////////
// Misc Dom elements creation functions
//////////////////////////////////////////////

function DomCreateConfigInput(tagname, name, description, defvalue, parent, action)
{
  DomCreateInputElement( {  id     : name,
                            label  : description,
                            type   : tagname,
                            name   : name,
                            checked: GM_getValue(name, defvalue),
                            click  : function(ev) {
                                      GM_setValue(name,this.checked);
                                      if(typeof(action)=='undefined') config_action_default();
                                      else                            action(this);
                                     }
                         }, parent );
}

function DomCreateConfigSelect(name, description, options, defvalue, parent, action)
{
   var index= GM_getValue(name, defvalue);
   DomCreateSelectElement( {
                              id   : name,
                              label: description,
                              options: options,
                              selectedIndex: (index<options.length ? index : -1),
                              change: function(ev) {
                                         GM_setValue(name,this.selectedIndex);
                                         if(typeof(action)=='undefined') config_action_default();
                                         else                            action(this);
                                      }
                           },parent );
}

function DomCreateLabel( description, properties, parent )
{
  var item=DomCreateElement( 'label', properties, parent )
  item.appendChild(document.createTextNode(description));
  return item;
}

function DomCreateInputElement( properties, parent )
{
  var element= document.createElement('input');
  for(var key in properties) {
    switch(typeof(properties[key])){
      case 'function': element.addEventListener( key, properties[key], true); break;
      default        : if(key!='label') element[key]= properties[key]; break;
    }
  }
  if(typeof(properties['label'])=='string'){
     var item= document.createElement("label");
     item.appendChild(element);
     item.appendChild(document.createTextNode(properties['label']));
     element= item;
  }
  if(typeof(parent)!='undefined') parent.appendChild(element);
  return element;
}

function DomCreateSelectElement( properties, parent )
{
  var element= document.createElement('select');
  if(typeof(properties['options'])!='undefined') {
    var html= '';
    var options= properties['options'];
    for(var index in options) {
      html= html + '<option value=\"'+index+'\">'+options[index]+'</option>';
    }
    element.innerHTML= html;
  }
  for(var key in properties) {
    switch(typeof(properties[key])){
      case 'function': element.addEventListener( key, properties[key], true); break;
      default        : if(key!='label' && key!='options') element[key]= properties[key]; break;
    }
  }
  if(typeof(properties['label'])=='string'){
     var item= document.createElement("label");
     item.appendChild(document.createTextNode(properties['label']));
     var div = document.createElement("div");
     div.appendChild(item);
     div.appendChild(element);
     element= div;
  }
  if(typeof(parent)!='undefined') parent.appendChild(element);
  return element;
}

function DomCreateFieldset( label, parent )
{
   var fieldset= document.createElement("fieldset");
   var legend  = document.createElement("legend");
   legend.appendChild(document.createTextNode(label));
   fieldset.appendChild(legend);
   if(typeof(parent)!='undefined') parent.appendChild(fieldset);
   return fieldset;
}

function DomCreateElement( tagname, properties, parent )
{
  var element= document.createElement(tagname);
  for(var key in properties) {
    switch(typeof(properties[key])){
      case 'function': element.addEventListener( key, properties[key], true); break;
      default        : element[key]= properties[key]; break;
    }
  }
 if(typeof(parent)!='undefined') parent.appendChild(element);
 return element;
}

////////////////
// BEGIN HERE //
////////////////
try {
  create_config();
} catch (err) { alert(err); };
